/*  StringAssoc is an association list [(a1,b1),...,(an,bn)].
    Copy File, replacing ai with bi. No substring is replaced twice. */
replace(File,StringAssoc):-
    format(user,"replacing ~w~n",[File]),
    get_codes(File,Codes),
    (Codes==[]->true;
    tell('__temp'),
    replace_aux(Codes,StringAssoc),
    told,
    copyFile('__temp',File)).

get_codes(File,Codes):-
    see(File),
    get_code(B),
    get_codes_aux(B,Codes),
    seen.

get_codes_aux(-1,Codes):-!,Codes=[].
get_codes_aux(B,[B|Codes]):-
    get0(NB),
    get_codes_aux(NB,Codes).
    
replace_aux([],StringAssoc):-!.
replace_aux(Bs,StringAssoc):-
    replace_aux_2(Bs,StringAssoc,Bs1),
    replace_aux(Bs1,StringAssoc).

replace_aux_2([B|Bs],[],Bs1):-put_code(B),Bs=Bs1.
replace_aux_2(Bs,[(Str,NStr)|Assoc],Bs1):-
    append(Str,Bs1,Bs),!,
    put_codes(NStr).
replace_aux_2(Bs,[_|Assoc],Bs1):-
    replace_aux_2(Bs,Assoc,Bs1).

copyFile(InFile,OutFile):-
    get_codes(InFile,Codes),
    tell(OutFile),
    put_codes(Codes),
    told.

put_codes([]).
put_codes([Code|Codes]):-
    put_code(Code),
    put_codes(Codes).
